from libqtile import layout
from libqtile.config import Match

from colors import colors

layout_theme = {
    "border_width": 1,
    "margin": 5,
    "border_focus": colors['green'],
    "border_normal": colors['cyan']
}

treetab_layout = {
    "font": "FiraCode Nerd Font",
    "fontsize": 10,
    "sections": [""],
    "section_fontsize": 8,
    "bg_color": colors['background'],
    "active_bg": colors['foreground'],
    "active_fg": colors['background'],
    "inactive_bg": colors['background'],
    "inactive_fg": colors['white'],
    "padding_y": 5,
    "section_top": 10,
    "panel_width": 100
}

layouts = [
    # layout.MonadWide(**layout_theme),
    # layout.Bsp(**layout_theme),
    # layout.Stack(num_stacks=2, **layout_theme),
    # layout.Columns(**layout_theme),
    # layout.RatioTile(**layout_theme),
    # layout.VerticalTile(**layout_theme),
    # layout.Matrix(**layout_theme),
    layout.MonadTall(**layout_theme),
    # layout.Max(**layout_theme),
    # layout.Tile(shift_windows=True, **layout_theme),
    layout.TreeTab(**treetab_layout),
    layout.Floating(**layout_theme)
]

floatrules = [
    *layout.Floating.default_float_rules,
    Match(wm_class="confirmreset"),  # gitk
    Match(wm_class="makebranch"),  # gitk
    Match(wm_class="maketag"),  # gitk
    Match(wm_class="ssh-askpass"),  # ssh-askpass
    Match(title="branchdialog"),  # gitk
    Match(title="pinentry"),  # GPG key password entry
]

floating_layout = layout.Floating(float_rules = floatrules, border_width = 0)
